# Class RBTreeNode<V, NEIGHBOR>

#### Type Parameters

- #### V = any

- #### NEIGHBOR extends RBTreeNode<V, NEIGHBOR> = RBTreeNodeNested<V>

#### Hierarchy

- BSTNode<V, NEIGHBOR>
  - RBTreeNode

#### Implements

- IRBTreeNode<V, NEIGHBOR>

- Defined in src/data-structures/binary-tree/rb-tree.ts:5

#####
Index

### Constructors

constructor

### Properties

_color

### Accessors

color
familyPosition
height
id
left
parent
right
val

## Constructors

### constructor

- new RBTreeNode<V, NEIGHBOR>(id, val?): RBTreeNode<V, NEIGHBOR>

- #### Type Parameters

  - #### V = any

  - #### NEIGHBOR extends RBTreeNode<V, NEIGHBOR, NEIGHBOR> = RBTreeNodeNested<V>

  #### Parameters

  - ##### id: number

  - ##### `Optional` val: V

  #### Returns RBTreeNode<V, NEIGHBOR>

  Overrides BSTNode.constructor

  - Defined in src/data-structures/binary-tree/rb-tree.ts:11

## Properties

### `Private` _color

_color: RBColor

- Defined in src/data-structures/binary-tree/rb-tree.ts:9

## Accessors

### color

- get color(): RBColor

- #### Returns RBColor

  - Defined in src/data-structures/binary-tree/rb-tree.ts:16
- set color(value): void

- #### Parameters

  - ##### value: RBColor

  #### Returns void

  - Defined in src/data-structures/binary-tree/rb-tree.ts:20

### familyPosition

- get familyPosition(): FamilyPosition

- The function determines the position of a node in a family tree structure.

  #### Returns FamilyPosition

  a value of type `FamilyPosition`.

  Implementation of IRBTreeNode.familyPosition

  Inherited from BSTNode.familyPosition

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:110

### height

- get height(): number

- #### Returns number

  Implementation of IRBTreeNode.height

  Inherited from BSTNode.height

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:98
- set height(v): void

- #### Parameters

  - ##### v: number

  #### Returns void

  Implementation of IRBTreeNode.height

  Inherited from BSTNode.height

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:102

### id

- get id(): number

- #### Returns number

  Implementation of IRBTreeNode.id

  Inherited from BSTNode.id

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:42
- set id(v): void

- #### Parameters

  - ##### v: number

  #### Returns void

  Implementation of IRBTreeNode.id

  Inherited from BSTNode.id

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:46

### left

- get left(): undefined | null | NEIGHBOR

- #### Returns undefined | null | NEIGHBOR

  Implementation of IRBTreeNode.left

  Inherited from BSTNode.left

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:62
- set left(v): void

- #### Parameters

  - ##### v: undefined | null | NEIGHBOR

  #### Returns void

  Implementation of IRBTreeNode.left

  Inherited from BSTNode.left

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:66

### parent

- get parent(): undefined | null | NEIGHBOR

- #### Returns undefined | null | NEIGHBOR

  Implementation of IRBTreeNode.parent

  Inherited from BSTNode.parent

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:88
- set parent(v): void

- #### Parameters

  - ##### v: undefined | null | NEIGHBOR

  #### Returns void

  Implementation of IRBTreeNode.parent

  Inherited from BSTNode.parent

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:92

### right

- get right(): undefined | null | NEIGHBOR

- #### Returns undefined | null | NEIGHBOR

  Implementation of IRBTreeNode.right

  Inherited from BSTNode.right

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:75
- set right(v): void

- #### Parameters

  - ##### v: undefined | null | NEIGHBOR

  #### Returns void

  Implementation of IRBTreeNode.right

  Inherited from BSTNode.right

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:79

### val

- get val(): undefined | V

- #### Returns undefined | V

  Implementation of IRBTreeNode.val

  Inherited from BSTNode.val

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:52
- set val(value): void

- #### Parameters

  - ##### value: undefined | V

  #### Returns void

  Implementation of IRBTreeNode.val

  Inherited from BSTNode.val

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:56

Generated using TypeDoc